<?php

require_once( dirname(__FILE__).'/base/basesavedfilter.php' );

/**
 * Autogenerated class SavedFilter_Model
 *
 * @todo: documentation
 */
class SavedFilter_Model extends BaseSavedFilter_Model {
	/**
	 * An array containing the custom column dependencies
	 */
	static public $rewrite_columns = array(
		'scope' => array('username'),
		'deletable' => array('username')
	);

	/**
	 * Get the scope as a string
	 */
	public function get_scope() {
		if( $this->get_username() === false ) {
			return 'global';
		}
		return 'user';
	}

	/**
	 * Get if current user is allowed to delete the object
	 */
	public function get_deletable() {
		switch( $this->get_scope() ) {
			case 'user': return true;
			case 'global': return op5auth::instance()->authorized_for('saved_filters_global');
		}
		return false;
	}

	/**
	 * Update filter string
	 *
	 * Also set the filter table when setting filter
	 */
	public function set_filter($value) {
		$parser = new LSFilter(new LSFilterPP(), new LSFilterMetadataVisitor());
		$metadata = $parser->parse( $value );

		if( $metadata === false ) throw new Exception("Error when type checking");

		parent::set_filter($value);
		$this->set_filter_table($metadata['name']);
	}
}
